﻿using System.Reflection;
using System.Runtime.Serialization; // add a reference as well
using System.Linq;

namespace Asn1TypeExplorer
{
    class Program
    {
        static void Main(string[] args)
        {
            // Using .NET reflection to access schema information 
            // (generated with the -genSchemaInfo compiler option). 
            // Look inside the generated classes and the .NET DataMember attributes for details.
            ReflectionProj.MyModule.InnerMsg myData = new ReflectionProj.MyModule.InnerMsg();
            myData.String = "Hello Attributes";
            myData.OptionalFlag = true;         

            // Exploring schema information - field names and optionality
            PropertyInfo[] props =
                     myData.GetType()
                      .GetProperties(BindingFlags.Public | BindingFlags.Instance)
                      .Where( p => System.Attribute.IsDefined(p, typeof(DataMemberAttribute), false))
                      .ToArray();

            foreach (var prop in props)
                foreach (DataMemberAttribute attr in prop.GetCustomAttributes(true))
                    System.Console.WriteLine("'{0}' is {1} required", attr.Name, attr.IsRequired ? "":"not");
            // Output:
            //  'string' is  required
            //  'optional-flag' is not required
        }
    }
}
